ArgumentException ArgumentException ArgumentException ArgumentException Class

Definizione

L'eccezione generata quando uno degli argomenti forniti a un metodo non è valido.The exception that is thrown when one of the arguments provided to a method is not valid.

public ref class ArgumentException : SystemException
[System.Runtime.InteropServices.ComVisible(true)]
[System.Serializable]
public class ArgumentException : SystemException
type ArgumentException = class
    inherit SystemException
    interface ISerializable
Public Class ArgumentException
Inherits SystemException
Ereditarietà
Derivato
Attributi
Implementazioni

Esempi

Nell'esempio seguente viene illustrato come generare e intercettare ArgumentExceptionun oggetto.The following example demonstrates how to throw and catch an ArgumentException. USA ArgumentException . GetType (). Proprietà Name per visualizzare il nome dell'oggetto eccezione e usa anche la Message proprietà per visualizzare il testo del messaggio di eccezione.It uses the ArgumentException.GetType().Name property to display the name of the exception object, and also uses the Message property to display the text of the exception message.

using namespace System;

static int DivideByTwo(int num) 
{
    // If num is an odd number, throw an ArgumentException.
    if ((num & 1) == 1)
        throw gcnew ArgumentException(String::Format("{0} is not an even number", num), 
                                      "num");

    // num is even, return half of its value.
    return num / 2;
}

void main() 
{
    // Define some integers for a division operation.
    array<int>^ values = { 10, 7 };
    for each (int value in values) {
        try {
           Console::WriteLine("{0} divided by 2 is {1}", value, DivideByTwo(value));
        }
        catch (ArgumentException^ e) {
           Console::WriteLine("{0}: {1}", e->GetType()->Name, e->Message);
        }
        Console::WriteLine();
    }
}
// This example displays the following output:
//     10 divided by 2 is 5
//     
//     ArgumentException: 7 is not an even number
//     Parameter name: num
using System;

public class Example 
{
    static void Main() 
    {
        // Define some integers for a division operation.
        int[] values = { 10, 7 };
        foreach (var value in values) {
            try {
               Console.WriteLine("{0} divided by 2 is {1}", value, DivideByTwo(value));
            }
            catch (ArgumentException e) {
               Console.WriteLine("{0}: {1}", e.GetType().Name, e.Message);
            }
            Console.WriteLine();
        }
    }

    static int DivideByTwo(int num) 
    {
        // If num is an odd number, throw an ArgumentException.
        if ((num & 1) == 1)
            throw new ArgumentException(String.Format("{0} is not an even number", num), 
                                      "num");

        // num is even, return half of its value.
        return num / 2;
    }
}
// This example displays the following output:
//     10 divided by 2 is 5
//     
//     ArgumentException: 7 is not an even number
//     Parameter name: num
Public Class Example
    Public Shared Sub Main()
        ' Define some integers for a division operation.
        Dim values() As Integer = { 10, 7 }

        For Each value In values
            Try 
               Console.WriteLine("{0} divided by 2 is {1}", value, DivideByTwo(value))
            Catch e As ArgumentException
               Console.WriteLine("{0}: {1}", e.GetType().Name, e.Message)
            End Try
            Console.WriteLine()
        Next
    End Sub
    
    Private Shared Function DivideByTwo(ByVal num As Integer) As Integer
        ' If num is an odd number, throw an ArgumentException.
        If (num And 1) = 1 Then
            Throw New ArgumentException(String.Format("{0} is not an even number", num), 
                                      "num")
        End If
        Return num \ 2
    End Function
End Class
' The example displays the following output:
'     10 divided by 2 is 5
'     
'     ArgumentException: 7 is not an even number
'     Parameter name: num

Commenti

ArgumentExceptionviene generata quando viene richiamato un metodo e almeno uno degli argomenti passati non soddisfa la specifica del parametro del metodo chiamato.ArgumentException is thrown when a method is invoked and at least one of the passed arguments does not meet the parameter specification of the called method. La ParamName proprietà identifica l'argomento non valido.The ParamName property identifies the invalid argument.

In genere, un' ArgumentException eccezione viene generata dal Common Language Runtime o da un'altra libreria di classi e indica un errore dello sviluppatore.Most commonly, an ArgumentException is thrown by the common language runtime or another class library and indicates developer error. Se si genera una ArgumentException dal codice, è necessario verificare che la Message proprietà dell'eccezione includa un messaggio di errore significativo che descrive l'argomento non valido e l'intervallo di valori previsto per l'argomento.If you throw an ArgumentException from your code, you should ensure that the exception's Message property includes a meaningful error message that describes the invalid argument and the expected range of values for the argument.

Le classi derivate ArgumentException primarie ArgumentOutOfRangeExceptiondi sono ArgumentNullException e.The primary derived classes of ArgumentException are ArgumentNullException and ArgumentOutOfRangeException. Queste classi derivate devono essere usate ArgumentExceptional posto di, tranne nei casi in cui nessuna delle classi derivate è accettabile.These derived classes should be used instead of ArgumentException, except in situations where neither of the derived classes is acceptable. Ad esempio, le eccezioni devono essere generate da:For example, exceptions should be thrown by:

  • ArgumentNullExceptionogni null volta che viene passato a un metodo che non lo accetta come argomento valido.ArgumentNullException whenever null is passed to a method that does not accept it as a valid argument.

  • ArgumentOutOfRangeExceptionQuando il valore di un argomento non è compreso nell'intervallo dei valori accettabili; ad esempio, quando il valore "46" viene passato come argomento month durante la creazione di un oggetto DateTime.ArgumentOutOfRangeException when the value of an argument is outside the range of acceptable values; for example, when the value "46" is passed as the month argument during the creation of a DateTime.

Se la chiamata al metodo non dispone di alcun argomento o se l'errore non implica gli argomenti stessi, InvalidOperationException è necessario utilizzare.If the method call does not have any argument or if the failure does not involve the arguments themselves, then InvalidOperationException should be used.

ArgumentExceptionUSA HRESULT COR_E_ARGUMENT, che ha il valore 0x80070057.ArgumentException uses the HRESULT COR_E_ARGUMENT, which has the value 0x80070057.

Per un elenco di valori di proprietà iniziali per un'istanza di ArgumentException, vedere il ArgumentException costruttori.For a list of initial property values for an instance of ArgumentException, see the ArgumentException constructors.

Costruttori

ArgumentException() ArgumentException() ArgumentException() ArgumentException()

Inizializza una nuova istanza della classe ArgumentException.Initializes a new instance of the ArgumentException class.

ArgumentException(SerializationInfo, StreamingContext) ArgumentException(SerializationInfo, StreamingContext) ArgumentException(SerializationInfo, StreamingContext) ArgumentException(SerializationInfo, StreamingContext)

Inizializza una nuova istanza della classe ArgumentException con dati serializzati.Initializes a new instance of the ArgumentException class with serialized data.

ArgumentException(String) ArgumentException(String) ArgumentException(String) ArgumentException(String)

Inizializza una nuova istanza della classe ArgumentException con un messaggio di errore specificato.Initializes a new instance of the ArgumentException class with a specified error message.

ArgumentException(String, Exception) ArgumentException(String, Exception) ArgumentException(String, Exception) ArgumentException(String, Exception)

Inizializza una nuova istanza della classe ArgumentException con un messaggio di errore specificato e un riferimento all'eccezione interna che è la causa dell'eccezione corrente.Initializes a new instance of the ArgumentException class with a specified error message and a reference to the inner exception that is the cause of this exception.

ArgumentException(String, String) ArgumentException(String, String) ArgumentException(String, String) ArgumentException(String, String)

Inizializza una nuova istanza della classe ArgumentException con un messaggio di errore specificato e il nome del parametro che genera questa eccezione.Initializes a new instance of the ArgumentException class with a specified error message and the name of the parameter that causes this exception.

ArgumentException(String, String, Exception) ArgumentException(String, String, Exception) ArgumentException(String, String, Exception) ArgumentException(String, String, Exception)

Inizializza una nuova istanza della classe ArgumentException con un messaggio di errore specificato, il nome del parametro e un riferimento all'eccezione interna che è la causa dell'eccezione corrente.Initializes a new instance of the ArgumentException class with a specified error message, the parameter name, and a reference to the inner exception that is the cause of this exception.

Proprietà

Data Data Data Data

Ottiene una raccolta di coppie chiave-valore che fornisce informazioni aggiuntive definite dall'utente relative all'eccezione.Gets a collection of key/value pairs that provide additional user-defined information about the exception.

(Inherited from Exception)
HelpLink HelpLink HelpLink HelpLink

Ottiene o imposta un collegamento al file della Guida associato all'eccezione.Gets or sets a link to the help file associated with this exception.

(Inherited from Exception)
HResult HResult HResult HResult

Ottiene o imposta HRESULT, un valore numerico codificato che viene assegnato a un'eccezione specifica.Gets or sets HRESULT, a coded numerical value that is assigned to a specific exception.

(Inherited from Exception)
InnerException InnerException InnerException InnerException

Ottiene l'istanza di Exception che ha causato l'eccezione corrente.Gets the Exception instance that caused the current exception.

(Inherited from Exception)
Message Message Message Message

Ottiene il messaggio di errore e il nome del parametro o, se non è stato impostato alcun nome di parametro, soltanto il messaggio di errore.Gets the error message and the parameter name, or only the error message if no parameter name is set.

ParamName ParamName ParamName ParamName

Ottiene il nome del parametro che ha causato questa eccezione.Gets the name of the parameter that causes this exception.

Source Source Source Source

Ottiene o imposta il nome dell'oggetto o dell'applicazione che ha generato l'errore.Gets or sets the name of the application or the object that causes the error.

(Inherited from Exception)
StackTrace StackTrace StackTrace StackTrace

Ottiene una rappresentazione di stringa dei frame immediati nello stack di chiamate.Gets a string representation of the immediate frames on the call stack.

(Inherited from Exception)
TargetSite TargetSite TargetSite TargetSite

Ottiene il metodo che genera l'eccezione corrente.Gets the method that throws the current exception.

(Inherited from Exception)

Metodi

Equals(Object) Equals(Object) Equals(Object) Equals(Object)

Determina se l'oggetto specificato è uguale all'oggetto corrente.Determines whether the specified object is equal to the current object.

(Inherited from Object)
GetBaseException() GetBaseException() GetBaseException() GetBaseException()

Se utilizzato come metodo di override in una classe derivata, restituisce l'Exception che è la causa radice di una o più eccezioni successive.When overridden in a derived class, returns the Exception that is the root cause of one or more subsequent exceptions.

(Inherited from Exception)
GetHashCode() GetHashCode() GetHashCode() GetHashCode()

Funge da funzione hash predefinita.Serves as the default hash function.

(Inherited from Object)
GetObjectData(SerializationInfo, StreamingContext) GetObjectData(SerializationInfo, StreamingContext) GetObjectData(SerializationInfo, StreamingContext) GetObjectData(SerializationInfo, StreamingContext)

Imposta l'oggetto SerializationInfo con il nome del parametro e informazioni aggiuntive sull'eccezione.Sets the SerializationInfo object with the parameter name and additional exception information.

GetType() GetType() GetType() GetType()

Ottiene il tipo di runtime dell'istanza corrente.Gets the runtime type of the current instance.

(Inherited from Exception)
MemberwiseClone() MemberwiseClone() MemberwiseClone() MemberwiseClone()

Crea una copia superficiale dell'oggetto Object corrente.Creates a shallow copy of the current Object.

(Inherited from Object)
ToString() ToString() ToString() ToString()

Crea e restituisce una rappresentazione di stringa dell'eccezione corrente.Creates and returns a string representation of the current exception.

(Inherited from Exception)

Eventi

SerializeObjectState SerializeObjectState SerializeObjectState SerializeObjectState

Si verifica quando un'eccezione viene serializzata per creare un oggetto di stato eccezione contenente i dati serializzati relativi all'eccezione.Occurs when an exception is serialized to create an exception state object that contains serialized data about the exception.

(Inherited from Exception)

Si applica a

Vedi anche